﻿using System;
using System.Collections.Generic;

namespace TSLab.Script.Handlers
{
    [HandlerCategory("Indicators")]
    public class AMA : BasePeriodIndicatorHandler, IDouble2DoubleHandler
    {
        public IList<double> Execute(IList<double> source)
        {
            return Calc(source, Period);
        }

        public static IList<double> Calc(IList<double> source, int period)
        {
            var count = source.Count;

            var res = new double[count];
            if (period > 0 && count > 0)
            {
                for (int k = 0; k <= period; k++)
                {
                    res[k] = source[k];
                }
                var ama0 = count < period ? 0 : source[period + 1];
                for (int k = period + 2; k < count; k++)
                {
                    var signal = Math.Abs(source[k] - source[k - period]);
                    var noise = 0.000000001;
                    for (int i = 0; i < period; i++)
                    {
                        noise = noise + Math.Abs(source[k - i] - source[k - i - 1]);
                    }
                    var er = signal / noise;
                    var ssc = (er * 0.60215) + 0.06452;
                    var cst = Math.Pow(ssc, 2);
                    var ama = ama0 + cst * (source[k] - ama0);
                    res[k] = ama;
                    ama0 = ama;
                }
            }
            return res;
        }
    }
}
