﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using TSLab.Script.Helpers;

namespace TSLab.Script.Handlers
{
    [InputsCountAttribute(1)]
    [InputAttribute(0, TemplateTypes.DOUBLE)]
    public abstract class ValueSupportedIndicator : IValuesHandlerWithNumber, IDoubleReturns, IContextUses
    {
        private double[] m_data, m_source;

        public double Execute(double source, int i)
        {
            if (m_data == null)
            {
                m_data = new double[Context.BarsCount];
                m_source = new double[Context.BarsCount];
            }
            m_source[i] = source;
            return Execute(m_source, m_data, i);
        }

        protected abstract double Execute(IList<double> source, IList<double> data, int num);

        public IContext Context { get; set; }
    }

    public abstract class ValueSupportedIndicatorWithPeriod : ValueSupportedIndicator
    {
        [HandlerParameter(true, "20", Min = "10", Max = "100", Step = "5")]
        public int Period
        {
            get;
            set;
        }
    }
}
